#include "Test2k2Gui.h"


Test2k2Gui::Test2k2Gui(const TGWindow *p, UInt_t w, UInt_t h)
    : TGMainFrame(p, w, h)
{


	SetLayoutBroken(kTRUE);

    fLayout = new TGLayoutHints(kLHintsNormal);

	// submenu firmware
	fSubMenuFirmware = new TGPopupMenu(gClient->GetRoot());
	fSubMenuFirmware->AddEntry("Change Cypress firmware",MENU_FIRMWARECYPRESS);
	fSubMenuFirmware->AddEntry("Change Altera firmware",MENU_FIRMWAREALTERA);

	// menu file
	fMenuFile = new TGPopupMenu(gClient->GetRoot());
	fMenuFile->Connect("Activated(Int_t)", "Test2k2Gui", this,"HandleMenu(Int_t)");
	fMenuFile->AddEntry("&Options",MENU_OPTIONS);
	fMenuFile->AddEntry("&CCDTookit",MENU_CCDTOOLKIT);
	fMenuFile->AddEntry("Show last &fits",MENU_RUNFITSVIEWER);
	fMenuFile->DisableEntry(MENU_RUNFITSVIEWER);
	fMenuFile->AddSeparator();
	fMenuFile->AddPopup("Firmware",fSubMenuFirmware);
	fMenuFile->AddEntry("Advanced actions",MENU_ADVANCEDACTIONS);
	fMenuFile->AddSeparator();
	fMenuFile->AddEntry("E&xit", MENU_EXIT);
	
	// menu	
	fMenuBar = new TGMenuBar(this , 1, 1, kHorizontalFrame);
    fMenuBarItemLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft, 0, 4, 0, 0);
	fMenuBarLayout = new TGLayoutHints(kLHintsTop | kLHintsExpandX);
	fMenuBar->AddPopup("&File", fMenuFile , fMenuBarItemLayout);
	fMenuBarLayout = new TGLayoutHints(kLHintsTop | kLHintsExpandX);
	fMenuBar->MoveResize(0,0);
	AddFrame(fMenuBar, fMenuBarLayout);
	
	// group temperature
	grTemp = new TGVButtonGroup(this,"Temperature");
	// one radio button can be selected
	grTemp->SetRadioButtonExclusive(kTRUE);
	grTemp->MoveResize(2,22,155,170);

    tlttemp1 = new TGLabel(grTemp,"CCDTemp:");
	tlttemp1->MoveResize(6,24,80,16);
	tliCCDTemp = new TGLabel(grTemp," n\\n");
	tliCCDTemp->MoveResize(88,24,50,16);
	grTemp->AddFrame(tlttemp1);
	grTemp->AddFrame(tliCCDTemp);

    tlttemp2 = new TGLabel(grTemp,"Case Temp:");
	tlttemp2->MoveResize(6,46,80,16);
	tliCaseTemp = new TGLabel(grTemp," n\\n");
	tliCaseTemp->MoveResize(88,46,50,16);
	grTemp->AddFrame(tlttemp2);
	grTemp->AddFrame(tliCaseTemp);

    tlttemp3 = new TGLabel(grTemp,"Ambient Temp:");
	tlttemp3->MoveResize(6,68,80,16);
	tliAmbientTemp = new TGLabel(grTemp,"n\\n");
	tliAmbientTemp->MoveResize(88,68,50,16);
	grTemp->AddFrame(tlttemp3);
	grTemp->AddFrame(tliAmbientTemp);

	tgnTemp = new TGNumberEntry(grTemp,10,7,0,TGNumberFormat::kNESInteger,
	TGNumberFormat::kNEAAnyNumber,TGNumberFormat::kNELLimitMinMax,0,20);//device->getMaxTempValue());
	tgnTemp->MoveResize(6,90);
	tbChangeTemp = new TGTextButton(grTemp,"Change temp");
	tbChangeTemp->Connect("Clicked()","Test2k2Gui",this,"setTemperature()");
	tbChangeTemp->MoveResize(75,90,74,20);

	grTemp->AddFrame(tgnTemp);
	grTemp->AddFrame(tbChangeTemp);

	// group cooling (insede group temperature)
	grCooling = new TGVButtonGroup(grTemp,"Cooling");
	grCooling->SetRadioButtonExclusive(kTRUE);
	grCooling->MoveResize(6,115,143,47);
    trbCoolingOn = new TGRadioButton(grCooling, "On");
    trbCoolingOn->Connect("Clicked(),","Test2k2Gui",this,"setCoolingOn()");
	trbCoolingOn->MoveResize(20,15); //,50,25);
    trbCoolingOff = new TGRadioButton(grCooling, "Off");
    trbCoolingOff->Connect("Clicked(),","Test2k2Gui",this,"setCoolingOff()");
    trbCoolingOff->MoveResize(80,15); //,50,25);
    trbCoolingOff->SetState(kButtonDown);
	grCooling->AddFrame(trbCoolingOn);
	grCooling->AddFrame(trbCoolingOff);
	 
	grTemp->AddFrame(grCooling,fLayout);

	this->AddFrame(grTemp,fLayout);

	// group shutter
	grShutter = new TGVButtonGroup(this,"Shutter");
	grShutter->MoveResize(163,22,165,170); 
	grShutter->SetRadioButtonExclusive(kTRUE);
    trbShutterOpened = new TGRadioButton(grShutter, "Permanently opened");
    trbShutterOpened->MoveResize(10,50);
    trbShutterOpened->Connect("Clicked()","Test2k2Gui",this,"setShutterOpened()");
    trbShutterClosed = new TGRadioButton(grShutter, "Normal mode");
    trbShutterClosed->MoveResize(10,80);
    trbShutterClosed->Connect("Clicked()","Test2k2Gui",this,"setShutterClosed()");
    trbShutterClosed->SetState(kButtonDown);
	grShutter->AddFrame(trbShutterOpened);
	grShutter->AddFrame(trbShutterClosed);
	frShutter = new TGHorizontalFrame(grShutter);
	frShutter->MoveResize(3,110,158,50);
	grShutter->AddFrame(frShutter);

    tgnShutter = new TGNumberEntry(frShutter,10.0,//device->getShutterTime()
		    7,0,TGNumberFormat::kNESRealOne,
    TGNumberFormat::kNEAAnyNumber,TGNumberFormat::kNELLimitMinMax,
	// kNESRealTwo
	0.1,100.0);
    tgnShutter->MoveResize(10,0);
    tgnShutter->IncreaseNumber(TGNumberFormat::kNSSHuge);
	tbChangeShutter = new TGTextButton(frShutter,"Change time");
	tbChangeShutter->MoveResize(80,0,74,20);
	
	tbChangeShutter->Connect("Clicked()","Test2k2Gui",this,"setShutterTime()");
	frShutter->AddFrame(tgnShutter);
	frShutter->AddFrame(tbChangeShutter);
	this->AddFrame(grShutter,fLayout);	
	
	//group picture
	grPicture = new TGVButtonGroup(this,"Pictures");
	grPicture->SetRadioButtonExclusive(kTRUE);
	grPicture->MoveResize(2,187,326,90);
	tltPicture =  new TGLabel(grPicture,"Number of images:");
	tltPicture->MoveResize(15,23);
    tgnPicture = new TGNumberEntry(grPicture,1,7,0,TGNumberFormat::kNESInteger,
    	TGNumberFormat::kNEANonNegative,TGNumberFormat::kNELLimitMinMax,1,100);
    tgnPicture->MoveResize(130,20);
    grPicture->AddFrame(tltPicture);
    grPicture->AddFrame(tgnPicture);
    tbGetPicture = new TGTextButton(grPicture,"Take picture(s)");
	tbGetPicture->MoveResize(200,20,98,20);
	
	tbGetPicture->Connect("Clicked()","Test2k2Gui",this,"takePictures()");
	grPicture->AddFrame(tbGetPicture); 	
	progBarPic = new TGHProgressBar(grPicture,TGProgressBar::kStandard,10);
	progBarPic->ShowPosition();
	progBarPic->MoveResize(15,50,280);

	progBarPic->SetBarColor("lightblue");
	grPicture->AddFrame(progBarPic);
	this->AddFrame(grPicture,fLayout);	

	statusBar = new TGStatusBar(this);	
	Int_t statusBarParts[2] = { 35, 65 };
	statusBar->SetParts(statusBarParts,2);
	statusBar->MoveResize(0,h-20,w,20);
	AddFrame(statusBar);
	statusBar->SetText("sample cod",0);

	// size
	SetWMSizeHints(GetWidth(), GetHeight(), GetWidth(), GetHeight(), 0, 0);

	this->Connect("myRedraw()","Test2k2Gui",this,"refreshInfo()");

//-------------
    MapSubwindows();

    Layout();

    SetWindowName("Test2K2Kgui ver 0.04");

    MapWindow();
}

Test2k2Gui::~Test2k2Gui() {
}

void Test2k2Gui::HandleMenu(Int_t item) {

	printf("HandleMenu\n");
	switch(item) {
		case MENU_EXIT:
			printf("MENU_EXIT\nBYE\n");
			CloseWindow();
			break;
		case MENU_OPTIONS:
			printf("MENU_OPTIONS\n");
			new GuiOptions(gClient->GetRoot(), this, 400, 200);
			break;
		default:
			printf("Unknown item: %d\n",item);	
	}	
}

void Test2k2Gui::CloseWindow() {
	gApplication->Terminate(0);
}

// all functions empty
void Test2k2Gui::setCoolingOn() {
}

void Test2k2Gui::setCoolingOff() {
}

void Test2k2Gui::setShutterTime() {
}

void Test2k2Gui::setShutterOpened() {
}

void Test2k2Gui::setShutterClosed() {
}

void Test2k2Gui::getInfo() {
}

void Test2k2Gui::setTemperature() {
}

void Test2k2Gui::takePictures() {
}

void Test2k2Gui::createThread() {
}

void Test2k2Gui::myRedraw() // *SIGNAL*
{
	Emit("myRedraw()");
}

void Test2k2Gui::refreshInfo() {
}

void Test2k2Gui::changeFirmwareCypress() {
}

void Test2k2Gui::changeFirmwareAltera() {
}
