#ifndef __TEST2K2KGUI__
#define __TEST2K2KGUI__

#include <TApplication.h> 
#include <TGClient.h>
#include <TGButton.h>
#include <TGLabel.h>
#include <TGNumberEntry.h>
#include <RQ_OBJECT.h>
#include <TGDockableFrame.h>
#include <TGMenu.h>
#include <TGButtonGroup.h>
#include <TGProgressBar.h>
#include <TGStatusBar.h>
#include <TSystem.h>
#include <TQObject.h>
#include <TGListTree.h>
#include <TGFileDialog.h>
#include "GuiOptions.h"

enum MenuItem {
	MENU_EXIT,
	MENU_OPTIONS,
	MENU_CCDTOOLKIT,
	MENU_TESTOPTIONS,
	MENU_RESETCAMERA,
	MENU_RUNFITSVIEWER,
	MENU_FIRMWARECYPRESS,
	MENU_FIRMWAREALTERA,
	MENU_ADVANCEDACTIONS	
};

class Test2k2Gui : public TGMainFrame {

RQ_OBJECT("Test2k2Gui")

private:

	// frames
	TGHorizontalFrame *fHframe1,*fHframe2;

	// menu
	TGDockableFrame    *fMenuDock;
	TGMenuBar          *fMenuBar;
	TGPopupMenu        *fMenuFile, *fSubMenuFirmware;
	TGLayoutHints      *fMenuBarLayout, *fMenuBarItemLayout;

	//layout
    TGLayoutHints   *fLayout, *fLayout2;

	// group temperature
	TGHorizontalFrame *frTemp1,*frTemp2,*frTemp3, *frTemp4;
	TGVButtonGroup	*grTemp;
    TGLabel			*tltCooling;
    TGLabel			*tlttemp1;
	TGLabel			*tliCCDTemp;
    TGLabel			*tlttemp2;
	TGLabel			*tliCaseTemp;
    TGLabel			*tlttemp3;
	TGLabel			*tliAmbientTemp;	 
	TGNumberEntry	*tgnTemp;
	TGTextButton	*tbChangeTemp;
	
	// group cooling
	TGVButtonGroup		*grCooling;
    TGRadioButton   *trbCoolingOn, *trbCoolingOff;

	// group shutter
	TGVButtonGroup	*grShutter;
	TGRadioButton	*trbShutterOpened, *trbShutterClosed;
	TGNumberEntry	*tgnShutter;
	TGTextButton	*tbChangeShutter;
	TGHorizontalFrame *frShutter;
	
	// group picture
	TGVButtonGroup	*grPicture;
	TGHorizontalFrame *frPic1;
	TGLabel			*tltPicture;
	TGNumberEntry	*tgnPicture;
	TGTextButton	*tbGetPicture;
	TGHProgressBar	*progBarPic;
	
	// status bar
	TGStatusBar *statusBar;
	
	void Test2k2Gui::createThread();

public:
    Test2k2Gui(const TGWindow *p, UInt_t w, UInt_t h);
    virtual ~Test2k2Gui();
	virtual void CloseWindow();
	virtual void HandleMenu(Int_t);

    void getInfo();
    void setTemperature();
    void setShutterTime();
    void setShutterOpened();
    void setShutterClosed();
    void setCoolingOn();
    void setCoolingOff();
    void takePictures();
    void myRedraw(); // *SIGNAL*
    void refreshInfo();
    void changeFirmwareCypress();
    void changeFirmwareAltera();
    
	ClassDef(Test2k2Gui,0)
   
};

#endif // __TEST2K2KGUI__
